<?php
//data_v4.php
//Amazon specific data for AWS version 4
//based on: http://docs.amazonwebservices.com/AWSECommerceService/2008-04-07/DG/
//20080730/wjvg

$Aoperation=array(
  'BrowseNodeLookup'=>array(
    'RequiredParameters'=>array(
      'BrowseNodeId'
    ),
    'OptionalParameters'=>array(
    ),
    'ResponseGroups'=>array(
      'BrowseNodeInfo','MostGifted','MostWishedFor','NewReleases','TopSellers',
    ),
  ),
  'CartAdd'=>array(
    'RequiredParameters'=>array(
      'CartId',
      'HMAC',
      'Item',
      'Items',
      'ListItemId',
      'Quantity',
    ),
    'OptionalParameters'=>array(
      'ASIN','MergeCart','OfferListingId',
    ),
    'ResponseGroups'=>array(
      'Cart','CartSimilarities','CartTopSellers','CartNewReleases',
    ),
  ),
  'CartClear'=>array(
    'RequiredParameters'=>array(
      'CartId',
      'HMAC',
    ),
    'OptionalParameters'=>array(
      'MergeCart',
    ),
    'ResponseGroups'=>array(
      'Cart',
    ),
  ),
  'CartCreate'=>array(
    'RequiredParameters'=>array(
      'AssociateTag','Item','Items','ListItemId','Quantity',
    ),
    'OptionalParameters'=>array(
      'ASIN','MergeCart','OfferListingId',
    ),
    'ResponseGroups'=>array(
      'Cart','CartSimilarities','CartTopSellers','CartNewReleases',
    ),
  ),
  'CartGet'=>array(
    'RequiredParameters'=>array(
      'CartId',
      'HMAC',
    ),
    'OptionalParameters'=>array(
      'MergeCart',
    ),
    'ResponseGroups'=>array(
      'Cart','CartSimilarities','CartTopSellers','CartNewReleases',
    ),
  ),
  'CartModify'=>array(
    'RequiredParameters'=>array(
      'ASIN','CartId','HMAC','Item','ListItemId','OfferListingId','Quantity',
    ),
    'OptionalParameters'=>array(
      'Items','MergeCart',
    ),
    'ResponseGroups'=>array(
      'Cart','CartSimilarities','CartTopSellers','CartNewReleases',
    ),
  ),
  'CustomerContentLookup'=>array(
    'RequiredParameters'=>array(
      'CustomerId',
    ),
    'OptionalParameters'=>array(
      'ReviewPage','TagPage','TagSort','TagsPerPage',
    ),
    'ResponseGroups'=>array(
      'CustomerInfo',
      'CustomerReviews',
      'CustomerLists',
      'CustomerFull',
      'TagsSummary',
      'Tags',
      'TaggedItems',
      'TaggedListmaniaLists',
      'TaggedGuides',
    ),
  ),
  'CustomerContentSearch'=>array(
    'RequiredParameters'=>array(
    ),
    'OptionalParameters'=>array(
      'CustomerPage','Email','Name',
    ),
    'ResponseGroups'=>array(
      'CustomerInfo',
    ),
  ),
  'Help'=>array(
    'RequiredParameters'=>array(
    ),
    'OptionalParameters'=>array(
    ),
    'ResponseGroups'=>array(
    ),
  ),
  'ItemLookup'=>array(
    'RequiredParameters'=>array(
      'ItemId',
    ),
    'OptionalParameters'=>array(
      'Condition',
      'DeliveryMethod',
      'ISPUPostalCode',
      'IdType',
      'MerchantId',
      'OfferPage',
      'RelatedItemPage',
      'RelationshipType',
      'ReviewPage',
      'ReviewSort',
      'SearchIndex',
      'TagPage',
      'TagSort',
      'TagsPerPage',
      'VariationPage',
    ),
    'ResponseGroups'=>array(
       'Small', 'Accessories', 'AlternateVersions', 'BrowseNodes',
       'Collections', 'EditorialReview', 'Images', 'ItemAttributes', 'ItemIds',
       'Large', 'ListmaniaLists', 'Medium', 'MerchantItemAttributes',
       'OfferFull', 'OfferListings', 'Offers', 'OfferSummary', 'PromotionalTag',
       'PromotionDetails', 'PromotionSummary', 'RelatedItems', 'Reviews',
       'SalesRank', 'SearchInside', 'Similarities', 'Subjects', 'Tags',
       'TagsSummary', 'Tracks', 'VariationImages', 'VariationMatrix',
       'VariationMinimum', 'VariationOffers', 'Variations',
       'VariationSummary',
    ),
  ),
  'ItemSearch'=>array(
    'RequiredParameters'=>array(
      'SearchIndex'=>array(
        'Actor',
        'Artist',
        'AudienceRating',
        'Author',
        'Brand',
        'BrowseNode',
        'City ',
        'Composer',
        'Conductor',
        'Director',
        'Keywords',
        'Manufacturer',
        'MusicLabel',
        'Neighborhood',
        'Orchestra',
        'Power',
        'Publisher',
        'TextStream',
        'Title',
      ),
    ),
    'OptionalParameters'=>array(
      'Actor',
      'Artist',
      'AudienceRating',
      'Author',
      'Availability',
      'Brand',
      'BrowseNode',
      'City ',
      'Composer',
      'Condition',
      'Conductor',
      'Cuisine',
      'DeliveryMethod',
      'Director',
      'DisableParentAsinSubstitution',
      'ISPUPostalCode',
      'Itempage',
      'Keywords',
      'Manufacturer',
      'MaximumPrice',
      'MerchantId',
      'MinimumPrice',
      'MusicLabel',
      'Neighborhood',
      'Orchestra',
      'PostalCode',
      'Power',
      'Publisher',
      'RelatedItemPage',
//    'RelatedItemsPage',
      'RelationshipType',
      'ReleaseDate',
      'ReviewSort',
      'Sort',
      'State',
      'TagPage',
      'TagSort',
      'TagsPerPage',
      'TextStream',
      'Title',
    ),
    'ResponseGroups'=>array(
      'Small',
      'Accessories',
      'AlternateVersions',
      'BrowseNodes',
      'Collections',
      'EditorialReview',
      'Images',
      'ItemAttributes',
      'ItemIds',
      'Large',
      'ListmaniaLists',
      'Medium',
      'MerchantItemAttributes',
      'OfferFull',
      'OfferListings',
      'Offers',
      'OfferSummary',
      'PromotionalTag',
      'PromotionDetails',
      'PromotionSummary',
      'RelatedItems',
      'Reviews',
      'SalesRank',
      'SearchBins',
      'SearchInside',
      'Similarities',
      'Subjects',
      'Tags',
      'TagsSummary',
      'Tracks',
      'VariationMatrix',
      'VariationMinimum',
      'VariationOffers',
      'Variations',
      'VariationSummary',
    ),
  ),
  'ListLookup'=>array(
    'RequiredParameters'=>array(
      'ListId','ListType',
    ),
    'OptionalParameters'=>array(
      'Condition',
      'DeliveryMethod',
      'ISPUPostalCode',
      'IsOmitPurchasedItems',
      'MerchantId',
      'ProductGroup',
      'ProductPage',
      'ReviewSort',
      'Sort',
    ),
    'ResponseGroups'=>array(
       'ListInfo', 'Accessories', 'BrowseNodes', 'EditorialReview',
       'Images', 'ItemAttributes', 'ItemIds', 'Large', 'ListFull', 'ListItems',
       'ListmaniaLists', 'Medium', 'OfferFull', 'OfferListings', 'Offers',
       'OfferSummary', 'PromotionDetails', 'PromotionSummary',
       'Reviews', 'SalesRank', 'Similarities', 'Small', 'Subjects', 'Tracks',
       'VariationMinimum', 'Variations', 'VariationSummary',
    ),
  ),
  'ListSearch'=>array(
    'RequiredParameters'=>array(
      'ListType',
    ),
    'OptionalParameters'=>array(
      'City',
      'Email',
      'FirstName',
      'LastName',
      'ListPage',
      'Name',
      'State',
    ),
    'ResponseGroups'=>array(
      'ListInfo','ListMinimum',
    ),
  ),
  'SellerListingLookup'=>array(
    'RequiredParameters'=>array(
      'Id','IdType',
    ),
    'OptionalParameters'=>array(
      'SellerId',
    ),
    'ResponseGroups'=>array(
      'SellerListing',
    ),
  ),
  'SellerListingSearch'=>array(
    'RequiredParameters'=>array(
      'SellerId',
    ),
    'OptionalParameters'=>array(
      'Keywords','ListingPage','OfferStatus','Sort',
    ),
    'ResponseGroups'=>array(
      'SellerListing',
    ),
  ),
  'SellerLookup'=>array(
    'RequiredParameters'=>array(
      'SellerId',
    ),
    'OptionalParameters'=>array(
      'FeedbackPage',
    ),
    'ResponseGroups'=>array(
      'Seller',
    ),
  ),
  'SimilarityLookup'=>array(
    'RequiredParameters'=>array(
      'ItemId',
    ),
    'OptionalParameters'=>array(
      'Condition',
      'DeliveryMethod',
      'ISPUPostalCode',
      'MerchantId',
      'ReviewSort',
      'SimilarityType',
    ),
    'ResponseGroups'=>array(
      'Small (D)', 'Accessories', 'BrowseNodes', 'EditorialReview',
      'Images', 'ItemAttributes', 'ItemIds', 'Large', 'ListmaniaLists',
      'Medium', 'OfferFull', 'OfferListings', 'Offers', 'OfferSummary',
      'PromotionDetails', 'PromotionSummary', 'Reviews',
      'SalesRank', 'Similarities', 'Subjects', 'Tracks',
      'VariationMinimum', 'Variations', 'VariationSummary',
    ),
  ),
  'TagLookup'=>array(
    'RequiredParameters'=>array(
      'TagName',
    ),
    'OptionalParameters'=>array(
      'Count','CustomerId','TagPage','TagSort',
    ),
    'ResponseGroups'=>array(
                  'TaggedItems (D)', 'TagsSummary (D)', 'Accessories',
                  'AlternateVersions', 'BrowseNodes', 'Collections',
                  'EditorialReview', 'Images', 'ItemAttributes', 'ItemIds', 'Large',
                  'ListmaniaLists', 'Medium', 'MerchantItemAttributes',
                  'OfferFull', 'OfferListings', 'Offers','OfferSummary',
                  'PromotionalTag', 'PromotionDetails', 'PromotionSummary',
                  'Reviews', 'SalesRank', 'SearchInside', 'Similarities', 'Small',
                  'Subjects', 'TaggedGuides', 'TaggedListmaniaLists', 'Tags',
                  'Tracks',
    ),
  ),
  'TransactionLookup'=>array(
    'RequiredParameters'=>array(
      'TransactionId',
    ),
    'OptionalParameters'=>array(
    ),
    'ResponseGroups'=>array(
      'PartnerTransactionDetails','TransactionDetails',
    ),
  ),
  'VehiclePartLookup'=>array(
    'RequiredParameters'=>array(
      'ItemId',
    ),
    'OptionalParameters'=>array(
      'BedId',
      'BodyStyleId',
      'BrakesId',
      'DriveTypeId',
      'EngineId',
      'FitmentCount',
      'FitmentPage',
      'IdType',
      'MakeId',
      'MfrBodyCodeId',
      'ModelId',
      'SpringTypesId',
      'SteeringId',
      'TransmissionId',
      'TrimId',
      'WheelbaseId',
      'Year',
    ),
    'ResponseGroups'=>array(
      'HasPartCompatibility',
      'Fitments',
      'VehiclePartFit',
    ),
  ),
  'VehiclePartSearch'=>array(
    'RequiredParameters'=>array(
      'MakeId',
      'ModelId',
      'Year',
    ),
    'OptionalParameters'=>array(
      'BedId',
      'BodyStyleId',
      'BrakesId',
      'Brand',
      'BrowseNodeId',
      'Count',
      'DriveTypeId',
      'EngineId',
      'FrontItemId',
      'MfrBodyCodeId',
      'PartPageDirection',
      'SpringTypesId',
      'SteeringId',
      'TransmissionId',
      'TrimId',
    ),
    'ResponseGroups'=>array(
      'VehicleParts',
      'HasPartCompatibility',
      'PartBrandBinsSummary',
      'PartBrowseNodeSummary',
      'VehiclePartFit',
    ),
  ),
  'VehicleSearch'=>array(
    'RequiredParameters'=>array(
    ),
    'OptionalParameters'=>array(
      'MakeId',
      'ModelId',
      'TrimId',
      'Year',
    ),
    'ResponseGroups'=>array(
      'VehicleYears',
      'VehicleMakes',
      'VehicleModels',
      'VehicleOptions',
      'VehicleTrims',
    ),
  ),
);

$Asearchindex=array(
  'All','Apparel','Automotive',
  'Baby','Beauty','Blended','Books',
  'Classical',
  'DVD','DigitalMusic',
  'Electronics',
  'GourmetFood','Grocery',
  'HealthPersonalCare','HomeGarden',
  'Industrial',
  'Jewelry',
  'KindleStore','Kitchen',
  'MP3Downloads','Magazines','Merchants','Miscellaneous','Music','MusicTracks','MusicalInstruments',
  'OfficeProducts','OutdoorLiving',
  'PCHardware','PetSupplies','Photo',
  'Shoes','SilverMerchants','Software','SportingGoods',
  'Tools','Toys',
  'UnboxVideo',
  'VHS','Video','VideoGames',
  'Watches','Wireless','WirelessAccessories',
);

//end
